enum { OUT0, OUT1, INZ };

const byte etatSortiePourLED[6][3] = {
  { OUT0, OUT1, INZ }, /* D0 */
  { OUT1, OUT0, INZ }, /* D1 */
  { INZ, OUT0, OUT1 }, /* D2 */
  { INZ, OUT1, OUT0 }, /* D3 */
  { OUT0, INZ, OUT1 }, /* D4 */
  { OUT1, INZ, OUT0 }  /* D5 */
};

enum { ALLUME, ETEINT };
 
byte etatLED[6] = {
    ETEINT, ETEINT, ETEINT, ETEINT, ETEINT, ETEINT
};

void programmeBroche(int numBroche, byte etat)
{
  switch (etat) {
    case OUT0:
      digitalWrite(numBroche,LOW);
      pinMode(numBroche,OUTPUT);
      break;
    case OUT1:
      digitalWrite(numBroche,HIGH);
      pinMode(numBroche,OUTPUT);
      break;
    case INZ:
      pinMode(numBroche,INPUT);
      digitalWrite(numBroche,LOW); /* pas de pullup */
      break;
  }
}

void gereLED(int num)
{
  if (etatLED[num] == ALLUME) {
    programmeBroche(10,etatSortiePourLED[num][0]);
    programmeBroche(11,etatSortiePourLED[num][1]);
    programmeBroche(12,etatSortiePourLED[num][2]);
  }
  else {
    programmeBroche(10,INZ);
    programmeBroche(11,INZ);
    programmeBroche(12,INZ);
  }
}

int numLED = 0;

int LEDAllumee = 0;
int compteur1s = 0;
 
void setup()
{
    /* Au début la LED 0 est allumée */
    etatLED[LEDAllumee] = ALLUME;
}
 
void loop()
{
    compteur1s++;
    if (compteur1s == 500) {
        /* Au bout de 1s, on allume la LED suivante */
        compteur1s = 0;
        /* Éteint la LED qui était allumée */
        etatLED[LEDAllumee] = ETEINT;
        /* Passe à la LED suivante */
        LEDAllumee++;
        if (LEDAllumee > 5)
            LEDAllumee = 0;
        /* Allume la nouvelle LED */
        etatLED[LEDAllumee] = ALLUME;
    }
 
    gereLED(numLED);
 
    numLED++;
    if (numLED > 5)
        numLED = 0;
 
    delay(2);
}

